#ifndef DETECTORCONSTRUCTION_HH
#define DETECTORCONSTRUCTION_HH

#include "G4VUserDetectorConstruction.hh"
#include "globals.hh"
#include "G4Material.hh"
#include "G4ThreeVector.hh"
#include "G4VSensitiveDetector.hh"

class G4LogicalVolume;

class DetectorConstruction : public G4VUserDetectorConstruction
{
public:
  DetectorConstruction();
  virtual ~DetectorConstruction();

  G4VPhysicalVolume* Construct();

private:
  G4LogicalVolume* fLogicNeut;
  G4LogicalVolume* fLogicWorld;

  G4VSensitiveDetector* fScintillatorSD;

  G4Material* fNeutMaterial;
  G4Material* fWorldMaterial;
};

#endif

