#ifndef DETECTORCONSTRUCTION_HH
#define DETECTORCONSTRUCTION_HH

#include "G4VUserDetectorConstruction.hh"

class G4LogicalVolume;
class G4Material;
class DetectorConstruction;
class DetectorConstructionMessenger;
class TargetConstruction;
class NeutronWindowConstruction;
class NeutronDetectorConstruction;

class DetectorConstruction : public G4VUserDetectorConstruction
{
public:
  DetectorConstruction();
  virtual ~DetectorConstruction();

  G4VPhysicalVolume* Construct();

  void UpdateGeometry();

protected:
  DetectorConstructionMessenger* fDetectorConstructionMessenger;

  NeutronDetectorConstruction* fNeutronDetectorConstruction;

  G4LogicalVolume* fLogicWorld;
  G4LogicalVolume* fLogicMONA;
  G4LogicalVolume* fLogicAir;

  G4Material* fWorldMaterial;
  G4Material* fAirMaterial;
};

#endif

