#ifndef ACTIONBASICMESSENGER_HH
#define ACTIONBASICMESSENGER_HH

#include "G4UImessenger.hh"

class G4UIdirectory;
class G4UIcmdWithABool;
class G4UIcmdWithAString;
class G4UIcmdWithAnInteger;
class G4UIcmdWithADoubleAndUnit;
class PrimaryGeneratorActionBasic;
class ActionCommonVariable;

// singleton pattern
class ActionBasicMessenger : public G4UImessenger
{
public:
  static ActionBasicMessenger* GetInstance();
  virtual ~ActionBasicMessenger();

  void Register(PrimaryGeneratorActionBasic* primaryGeneratorActionBasic);

  void SetNewValue(G4UIcommand*, G4String);

protected:
  static ActionBasicMessenger* fActionBasicMessenger;

  PrimaryGeneratorActionBasic* fPrimaryGeneratorActionBasic;
  ActionCommonVariable* fActionCommonVariable;

  G4UIdirectory* fActionDir;
  G4UIcmdWithAString* fRunNameCmd;
  G4UIcmdWithAString* fOverWriteCmd;
  G4UIcmdWithABool* fUseTreeCmd;
  G4UIcmdWithAString* fTreeNameCmd;
  G4UIcmdWithAString* fTreeTitleCmd;
  G4UIcmdWithAString* fBeamTypeCmd;
  G4UIcmdWithADoubleAndUnit* fBeamEnergyCmd;
  G4UIcmdWithADoubleAndUnit* fBeamSigmaCmd;
  G4UIcmdWithADoubleAndUnit* fBeamThetaCmd;

  G4UIdirectory* fActionDemocraticDecayDir;
  G4UIcmdWithADoubleAndUnit* fDecayErelCmd;
  G4UIcmdWithAnInteger* fDecayAbeamCmd;
  G4UIcmdWithAnInteger* fDecayZbeamCmd;
  G4UIcmdWithAnInteger* fDecayAcoreCmd;
  G4UIcmdWithAnInteger* fDecayZcoreCmd;

private: // hidden
  ActionBasicMessenger();
  ActionBasicMessenger(const ActionBasicMessenger& actionMessenger);
  ActionBasicMessenger& operator=(const ActionBasicMessenger& actionMessenger);
};

#endif

