#ifndef TARGETCONSTRUCTION_HH
#define TARGETCONSTRUCTION_HH

#include "G4VUserDetectorConstruction.hh"
#include "G4ThreeVector.hh"

class G4LogicalVolume;
class G4Material;
class DetectorConstruction;

class TargetConstruction : public G4VUserDetectorConstruction
{
  friend class DetectorConstruction;
  
public:
  TargetConstruction();
  virtual ~TargetConstruction();

  G4VPhysicalVolume* Construct();
  virtual G4LogicalVolume* ConstructSub();

  G4ThreeVector GetTargetSize(){return fTargetSize;}

protected:
  G4ThreeVector fTargetSize;

  G4LogicalVolume* fLogicTarget;
  G4LogicalVolume* fLogicWorld;

  G4Material* fTargetMaterial;
  G4Material* fWorldMaterial;
};

#endif

