#ifndef TSIMULATIONDATABEAM_HH
#define TSIMULATIONDATABEAM_HH

#include "TObject.h"
#include "TVector3.h"

#include <vector>

class TSimulationDataBeam;
typedef std::vector<TSimulationDataBeam> TSimulationDataBeamArray;

extern TSimulationDataBeamArray* gSimulationDataBeamArray;

class TSimulationDataBeam : public TObject
{
public:
  TSimulationDataBeam();
  virtual ~TSimulationDataBeam();

  friend ostream& operator<<(ostream& out,  const TSimulationDataBeam& simulationDataBeam);

public:
  Int_t fPrimaryParticleID;
  Int_t fPDGCode;
  Double_t fMass;
  Double_t fCharge;
  TVector3 fMomentum;
  TVector3 fPosition;
  Double_t fTime;

  std::vector<Double_t> fUserDouble;
  std::vector<Int_t> fUserInt;

  ClassDef(TSimulationDataBeam, 1)
};

#endif
