#ifndef TSIMULATIONDATASCINTILLATOR_HH
#define TSIMULATIONDATASCINTILLATOR_HH

#include "TObject.h"
#include "TString.h"
#include "TVector3.h"

#include <vector>

class TSimulationDataScintillator;
typedef std::vector<TSimulationDataScintillator> TSimulationDataScintillatorArray;

extern TSimulationDataScintillatorArray* gSimulationDataScintillatorArray;

class TSimulationDataScintillator : public TObject
{
public:
  TSimulationDataScintillator();
  virtual ~TSimulationDataScintillator();

  friend ostream& operator<<(ostream& out,  const TSimulationDataScintillator& simulationDataScintillator);

public:
  TString fSensitiveDetectorName;
  TString fModuleName;
  std::vector<Int_t> fModuleID;
  Int_t fPrimaryParticleID;
  Int_t fPDGCode;
  TString fParticleName;
  TString fProcessName;
  TVector3 fPrePosition;
  TVector3 fPostPosition;
  TVector3 fPreMomentum;
  TVector3 fPostMomentum;
  Double_t fPreKineticEnergy;
  Double_t fPostKineticEnergy;
  Double_t fPreTime;
  Double_t fPostTime;
  Double_t fEnergyDeposit;

  std::vector<Double_t> fUserDouble;
  std::vector<Int_t> fUserInt;

  ClassDef(TSimulationDataScintillator, 1)
};

#endif
