
#include "TDataInitializerBulk.hh"

#include "TFile.h"
#include "TTree.h"

#include <iostream>

#include "TSimulationDataBeam.hh"
#include "TSimulationParameterGlobal.hh"
#include "TSimulationDataScintillator.hh"

ClassImp(TDataInitializerBulk)

TDataInitializerBulk::TDataInitializerBulk()
  : TDataInitializerInterface()
{;}

TDataInitializerBulk::~TDataInitializerBulk()
{;}

int TDataInitializerBulk::Initialize()
{
  delete gSimulationDataBeamArray; gSimulationDataBeamArray = 0;
  delete gSimulationDataScintillatorArray; gSimulationDataScintillatorArray = 0;
  gSimulationDataBeamArray = new TSimulationDataBeamArray;
  gSimulationDataScintillatorArray = new TSimulationDataScintillatorArray;

  return 1;
}

int TDataInitializerBulk::CreateBranch(TTree* tree)
{
  tree->Branch("beam", gSimulationDataBeamArray);
  tree->Branch("bulk", gSimulationDataScintillatorArray);

  return 1;
}

int TDataInitializerBulk::AddParameters(TFile* file)
{
  file->Add(gSimulationParameterGlobal);

  return 1;
}

int TDataInitializerBulk::RemoveParameters(TFile* file)
{
  file->Remove(gSimulationParameterGlobal);

  return 1;
}

int TDataInitializerBulk::PrintParameters(TFile* file)
{
  std::cout << "\n parameters of TDataInitializerBulk:" << std::endl;

  TSimulationParameterGlobal* simParaGlobal;

  file->GetObject("parameterGlobal", simParaGlobal);
  if(!simParaGlobal){
    std::cerr << " SimParaGlobal does not exist" << std::endl;
    return 0;
  }
  std::cout << " " << *simParaGlobal << "\n"
    	    << std::endl;

  return 1;
}

int TDataInitializerBulk::ClearBuffer()
{
  gSimulationDataScintillatorArray->clear();

  return 1;
}
