
#include "TDataInitializerGammaDetector.hh"

#include "TFile.h"
#include "TTree.h"

#include <iostream>

#include "TSimulationDataBeam.hh"
#include "TSimulationParameterGlobal.hh"
#include "TSimulationDataScintillator.hh"

ClassImp(TDataInitializerGammaDetector)

TDataInitializerGammaDetector::TDataInitializerGammaDetector()
  : TDataInitializerInterface()
{;}

TDataInitializerGammaDetector::~TDataInitializerGammaDetector()
{;}

int TDataInitializerGammaDetector::Initialize()
{
  delete gSimulationDataBeamArray; gSimulationDataBeamArray = 0;
  delete gSimulationDataScintillatorArray; gSimulationDataScintillatorArray = 0;
  gSimulationDataBeamArray = new TSimulationDataBeamArray;
  gSimulationDataScintillatorArray = new TSimulationDataScintillatorArray;

  return 1;
}

int TDataInitializerGammaDetector::CreateBranch(TTree* tree)
{
  tree->Branch("beam", gSimulationDataBeamArray);
  tree->Branch("gammaDetector", gSimulationDataScintillatorArray);

  return 1;
}

int TDataInitializerGammaDetector::AddParameters(TFile* file)
{
  file->Add(gSimulationParameterGlobal);

  return 1;
}

int TDataInitializerGammaDetector::RemoveParameters(TFile* file)
{
  file->Remove(gSimulationParameterGlobal);

  return 1;
}

int TDataInitializerGammaDetector::PrintParameters(TFile* file)
{
  std::cout << "\n  parameters of TDataInitializerGammaDetector:" << std::endl;

  TSimulationParameterGlobal* simParaGlobal;

  file->GetObject("parameterGlobal", simParaGlobal);
  if(!simParaGlobal){
    std::cerr << " SimParaGlobal does not exist" << std::endl;
    return 0;
  }
  std::cout << " " << *simParaGlobal << "\n"
    	    << std::endl;

  return 1;
}

int TDataInitializerGammaDetector::ClearBuffer()
{
  gSimulationDataScintillatorArray->clear();

  return 1;
}
